/*
   File: agfl-as.c
   Defines main program for agfl-as

   Copyright 2009 Radboud University of Nijmegen

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id$"   
*/

/* System includes */
#include <stdio.h>
#include <stdlib.h>

/* Local includes */
#include "options.h"
#include "lexer.h"
#include "parser.h"

int main (int argc, char **argv)
{ int err;
  parse_command_line (argc, argv);
  err = prepare_pass_one ();
  if (err != 0) return (1);
  parse_input ();
  finish_pass_one ();
  err = prepare_pass_two ();
  if (err != 0) return (1);
  parse_input ();
  finish_pass_two ();
  return (0);
}
