/*
   File: entries.h
   Maintains lexicon/fact/triple entries

   Copyright 2009 Radboud University of Nijmegen

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id$"
*/
#ifndef IncEntries
#define IncEntries

/* libabase inclusion */
#include <abase_fileutil.h>

/* Local include */
#include "dyn_array.h"

/* Exported routines */
int register_critical_text (char *text);
void register_new_entry (int *info_ptr, int call_id, int frequency, int multi_token_bonus);
int *enter_into_lexicon (char *lexeme_ptr, int lexeme_marker);
int *enter_into_fact_table (int fact_nr, int *key);

/* Init, output and finish */
int nr_of_entries ();
int nr_of_entry_lists ();
void generate_entries_info (FILE *info);
void bin_save_entries (BinFile bf);
void bin_save_vocabularies (BinFile bf);
void bin_save_fact_tables (BinFile bf);
void dump_vocabulary_entries (FILE *dump);
void dump_fact_tables (FILE *dump);
void init_entries ();
void squash_unique_frequencies (void);
void apply_bonuses_for_multiwords (void);

#endif /* IncEntries */
